///////////////////////////////////////////////////////////////////////////////
// Win32 Application Template
///////////////////////////////////////////////////////////////////////////////
#include	<stdio.h>
#include	<windows.h>
#include	<commdlg.h>
#include	<mmsystem.h>

#define	IDC_EDIT	1000

typedef struct{
	HWND				hEdit;
	HANDLE				hFile;
}	TIMERSTRUCT;

char	szWinName[] = "Template";	// EBhENX̖O

ATOM InitApplication(HINSTANCE hInstance);
HWND InitInstance(HINSTANCE hInstance, int nCmdShow);
LRESULT CALLBACK WindowFunc(HWND hWnd, UINT uMes, WPARAM wp, LPARAM lp);
BOOL QuitMessage(HWND hWnd);
void CALLBACK TimerProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1,
						DWORD dw2);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow){
	HWND				hWnd;
	MSG					msg;
	
	if(!InitApplication(hInstance))
		return FALSE;
	
	if(NULL == (hWnd = InitInstance(hInstance, nCmdShow)))
		return FALSE;
	
	// bZ[W[v𐶐
	while(1){
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			if(msg.message == WM_QUIT)
				break;
			TranslateMessage(&msg);	// L[{[hgp\ɂ
			DispatchMessage(&msg);	// Rg[Windowsɖ߂
		}
		// Idle
	}
	
	return msg.wParam;
}

ATOM InitApplication(HINSTANCE hInstance){
	WNDCLASSEX	wcl;

	// EBhENX`
	wcl.hInstance = hInstance;		// ̃CX^X̃nh
	wcl.lpszClassName = szWinName;	// EBhENX
	wcl.lpfnWndProc = WindowFunc;	// EBhE֐
	wcl.style = 0;					// ftHg̃X^C
	wcl.cbSize = sizeof(WNDCLASSEX);// WNDCLASSEX\̂̃TCY
	wcl.hIcon = NULL;				// [WACR
	wcl.hIconSm = NULL;				// X[ACR
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
									// J[\X^C
	wcl.lpszMenuName = NULL,		// j[Ȃ
	wcl.cbClsExtra = 0;				// GLXgȂ
	wcl.cbWndExtra = 0;				// KvȃCtH[V

	// EBhE𔒂ɂ
	wcl.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);

	// EBhENXo^
	return RegisterClassEx(&wcl);
}

HWND InitInstance(HINSTANCE hInstance, int nCmdShow){
	HWND		hWnd;

	// EBhENX̓o^ł̂ŁCEBhENGCgł
	hWnd = CreateWindow(
		szWinName,					// EBhENX̖O
		"Template",					// ^Cg
		WS_OVERLAPPEDWINDOW,		// EBhEX^C-m[}
		CW_USEDEFAULT,				// XW-WindowsɔC
		CW_USEDEFAULT,				// YW-WindowsɔC
		CW_USEDEFAULT,				// -WindowsɔC
		CW_USEDEFAULT,				// -WindowsɔC
		HWND_DESKTOP,				// eEBhEȂ
		NULL,						// j[Ȃ
		hInstance,					// ̃vÕCX^X̃nh
		NULL						// ǉȂ
	);
	if(NULL == hWnd)
		return NULL;

	// EBhE\
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return hWnd;
}

// ̊֐́CWindowsĂяoāCbZ[WL[
// bZ[Ẅn󂯂
LRESULT CALLBACK WindowFunc(HWND hWnd, UINT uMsg, WPARAM wp, LPARAM lp){
	HINSTANCE			hInstance;
	RECT				Rect;
	char				lpszFileName[MAX_PATH] = "";
	OPENFILENAME		stOfn;
	static UINT			uTimerID;
	static TIMERSTRUCT	stTimer;
	
	hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	
	switch(uMsg){
	case WM_CREATE:					// EBhE̍쐬
		GetClientRect(hWnd, &Rect);
		stTimer.hEdit = CreateWindow("EDIT", "",
			WS_CHILD | WS_VISIBLE
			| ES_MULTILINE | ES_LEFT | ES_WANTRETURN
			| ES_AUTOVSCROLL | WS_VSCROLL,
			0, 0, Rect.right, Rect.bottom,
			hWnd, (HMENU)IDC_EDIT, hInstance, NULL);

		ZeroMemory(&stOfn, sizeof(OPENFILENAME));
		stOfn.lStructSize	= sizeof(OPENFILENAME);
		stOfn.hwndOwner		= hWnd;
		stOfn.lpstrFilter
			= "CSV File(*.csv)\0*.csv\0All Files(*.*)\0*.*\0\0";
		stOfn.lpstrFile		= lpszFileName;
		stOfn.lpstrDefExt	= "csv";
		stOfn.nMaxFile		= MAX_PATH;
		stOfn.Flags			= OFN_OVERWRITEPROMPT;
		
		if(GetSaveFileName(&stOfn) == TRUE){
			stTimer.hFile = CreateFile((LPCTSTR)stOfn.lpstrFile,
				GENERIC_WRITE,
				FILE_SHARE_WRITE,
				NULL,
				CREATE_ALWAYS,
				FILE_ATTRIBUTE_NORMAL,
				(HANDLE)NULL);
			if(stTimer.hFile == (HANDLE)-1){
				MessageBox(hWnd, "File open faild.", NULL, MB_OK);
				PostMessage(hWnd, WM_CLOSE, 0, 0L);
				break;
			}
		}else{
			MessageBox(hWnd, "File name get faild.", NULL, MB_OK);
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
			break;
		}
		timeBeginPeriod(1);
		uTimerID = timeSetEvent(1000, 2, TimerProc,
			(DWORD)&stTimer, TIME_PERIODIC);
		break;
	case WM_DESTROY:				// ~Ƃ̏
		PostQuitMessage(0);			// EBhȄID0  Exit code
		break;
	case WM_CLOSE:					// eEBhEWM_DESTROY𔭍s
		if(QuitMessage(hWnd)){		// I̊mF
			CloseHandle(stTimer.hFile);
			timeKillEvent(uTimerID);
			timeEndPeriod(1);
			DestroyWindow(stTimer.hEdit);
									// GfBbgRg[̔j
			DestroyWindow(hWnd);	// CEBhE̔jDWM_DESTROYs
		}
		break;
	case WM_COMMAND:
		if(HIWORD(wp) == EN_MAXTEXT)
			SetWindowText((HWND)lp, NULL);
		break;
	default:						// LȊOWindowsɏ
		return DefWindowProc(hWnd, uMsg, wp, lp);
	}
	return 0;
}

BOOL QuitMessage(HWND hWnd){
	if(MessageBox(hWnd, (LPCSTR)"I܂H", (LPCSTR)"ImF",
		MB_YESNO | MB_ICONQUESTION) == IDYES)
		return TRUE;
	return FALSE;
}

void CALLBACK TimerProc(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1,
						DWORD dw2){
	char				lpszMessage[128];
	SYSTEMTIME			stSystemTime;
	TIMERSTRUCT *		lpstTimer = (TIMERSTRUCT *)dwUser;
	
	GetLocalTime(&stSystemTime);
	sprintf(lpszMessage, "%02lu:%02lu:%02lu.%03lu\xd\xa",
		stSystemTime.wHour,   stSystemTime.wMinute,
		stSystemTime.wSecond, stSystemTime.wMilliseconds);
	SendMessage(lpstTimer->hEdit, EM_REPLACESEL, FALSE, (LPARAM)lpszMessage);

	DWORD				dwBytesWrite;
	WriteFile(lpstTimer->hFile, (LPVOID)lpszMessage, strlen(lpszMessage),
		&dwBytesWrite, NULL);
	if(dwBytesWrite == 0){
		SendMessage(lpstTimer->hEdit, EM_REPLACESEL, FALSE,
			(LPARAM)"Zero bytes write.\xd\xa");
	}
}
